/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * callbacks.h
 * Copyright (C) chaitanya chandel 2009 <cchandel@yahoo.com>
 * 
 * callbacks.h is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * callbacks.h is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "db_sqlite.h"
#include <Elementary.h>

#define SMALL 0
#define LARGE 1

double keypress_time;
extern int *seq, no_songs, fd, pid, priority, bt, play_state, depth, songs_scanned, albums_scanned, scanning;
extern char order_by[254];

extern Ecore_Timer *timer1;
extern FILE *mp_data;
extern pthread_t thread_id;
extern Evas_Object *set_page_win, *play_cur_pos, *play_dur, *pos_slider, *ic_play, *im, *song_lb, *artist_lb, *lyrics_entry, *songs_dir_lb;
extern Evas_Object *ic_shuffle, *ic_repeat, *select_songs_page_win, *sel_songs_win, *manage_songs_page_win, *popup_lb, *popup_bt;
extern Evas_Object *lyrics_sc, *list_box, *ic_view, *c_play_list, *home_list, *shuffle_hv;
extern Ecore_Timer *scan_timer;

extern void next_button_clicked(void *data, Evas_Object *obj, void *event_info);
extern void prev_button_clicked(void *data, Evas_Object *obj, void *event_info);
extern void play_button_clicked(void *data, Evas_Object *obj, void *event_info);
extern void start_mplayer(void);
extern void popup_message(char *message, char *msg, int butt_state);
extern int check_file_exists(char *path);
extern void set_song_info(void);
extern void bluetooth_on(void);
extern void bluetooth_off(void);
extern void setup_ty_playlist(Evas_Object *li);
extern void toggle_view (void *data, Evas_Object *obj, void *event_info);
extern void create_playlist_page(void *data, Evas_Object *obj, void *event_info);
extern void add_song_dir(char *path);
extern int remove_song_dir(char *path);
extern void create_manage_playlist_page(void);
extern void populate_home_list(Evas_Object *li);

void restart_normal_mplayer(void);
void show_song_info(void);
void show_song_lyrics(void);
int set_duration(void);
void song_select_play(void *data, Evas_Object *obj, void *event_info);
Eina_Bool update_scan_popup(void *);
void song_scan(void);
void temp_playlist(void *data, Evas_Object *obj, void *event_info);
